import * as React from "react";
declare type commonInterface = CalendarSpace.commonInterface;
declare type Props = {
    selTimeObj: commonInterface["showTimeObj"];
    showViewArr: ("fadeIn" | "fadeOut")[];
    viewIndex: 0 | 1;
    rotate: commonInterface["rotate"];
    curTime: commonInterface["curTime"];
    fixProps: CalendarSpace.fixProps;
    changeBasicState: commonInterface["changeBasicState"];
};
declare type States = {
    showTimeObj: commonInterface["showTimeObj"];
    lastYear: number;
};
interface ICalendarView {
    changeSelTimeItme(viewIndex: number): void;
}
export default class CalendarView extends React.PureComponent<Props, States> implements ICalendarView {
    constructor(props: Props);
    getShowTimeObj(selTimeObj: commonInterface["showTimeObj"], curTime: commonInterface["curTime"]): IImmutalbeMap<{
        year: number;
        searson: number;
        month: number;
        day: number;
        hour: number;
        minute: number;
    }>;
    getLastYear(year: number): number;
    updatePanelYears(movePre: "next" | "back"): void;
    changeSelTimeItme: (viewIndex: number) => void;
    clickSelHandle: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    updatePanelDays(movePre: "next" | "back"): void;
    changeView: (e: React.MouseEvent<HTMLSpanElement, MouseEvent>) => void;
    changeRotate: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    controlBtnHandle: (e: React.MouseEvent<HTMLSpanElement, MouseEvent>) => void;
    getRotateCombo(arr: string[]): JSX.Element[];
    getSelTime(): JSX.Element | undefined;
    changeTime: (e: React.ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export {};
