import * as React from "react";
import { calendarType } from './objectFn';
declare type commonInterface = CalendarSpace.commonInterface;
declare type Props = {
    field: string;
    rotate?: commonInterface["rotate"];
    style?: 1 | 2;
    time?: boolean;
    noInp?: boolean;
    defaultTime?: string;
    width?: number;
    placeholder?: string;
    ableClear?: boolean;
    initTime?: {
        time: string;
    };
    renderCallBack?: boolean;
    noChangeRotate?: boolean;
    clickBack: (timeStr: string, field: string, rotate: commonInterface["rotate"], selTimeList: CalendarSpace.CalendarStates["selTimeArr"]) => void | boolean;
};
declare type States = CalendarSpace.CalendarStates & {
    preRotate: Props['rotate'];
    preInitTime: Props['initTime'];
};
declare type fixProps = CalendarSpace.fixProps;
interface ICalendar {
    curTime: commonInterface["curTime"];
    fixProps: fixProps;
    changeBasicState: commonInterface["changeBasicState"];
    createFixProps(): fixProps;
    getShowViewArr(rotate: commonInterface["rotate"]): States["showViewArr"];
}
declare class Calendar extends React.PureComponent<Props, States> implements ICalendar {
    static defaultProps: {
        rotate: calendarType;
        style: number;
        defaultTime: string;
        width: number;
        placeholder: string;
    };
    static getDerivedStateFromProps(nextProps: Props, preState: States): Partial<States> | null;
    curTime: {
        year: number;
        searson: number;
        month: number;
        day: number;
        hour: number;
        minute: number;
    };
    wrapDomRef: React.RefObject<HTMLDivElement>;
    fixProps: {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    constructor(props: Props);
    getShowViewArr(rotate: commonInterface["rotate"]): ("fadeIn" | "fadeOut")[];
    compareTimeRang(selTimeArr: CalendarSpace.CalendarStates["selTimeArr"], viewIndex: number, showTimeObj: commonInterface["curTime"], rotate: commonInterface["rotate"], time: boolean): boolean;
    changeBasicState: <K extends "expand" | "rotate" | "showViewArr" | "selTimeArr" | "calendarVal" | "preRotate" | "preInitTime">(key: K, callback: (states: States) => States[K], obj?: {
        showTimeObj: {
            year: number;
            searson: number;
            month: number;
            day: number;
            hour: number;
            minute: number;
        };
        viewIndex: number;
    } | undefined) => boolean | undefined;
    createFixProps(): {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    documentClickFn: (e: MouseEvent) => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    timeStrToNumber(strArr: string[]): string[];
    getSelTimeVal(): string;
    render(): JSX.Element;
}
export default Calendar;
