import * as React from "react";
declare enum activeStatus {
    select = "selected",
    hasSelect = "hasSelect",
    noSelect = "noSelect"
}
declare type comboType = keyof ComboSpace.IDrop;
declare type props<P extends comboType> = {
    node: IImmutalbeMap<any>;
    fieldObj: ComboSpace.drop<P>["filedObj"];
    index: string;
    lev?: number;
    CheckBox?: React.ComponentType<ComboSpace.ICheckboxCom>;
    checkMethod?: (value: string) => void;
    formatterDropItem?: (node: IImmutalbeMap<any>) => React.ReactNode;
    clickFn(index: string): void;
};
declare type states = {};
interface IDropItem {
    getCheckbox(text: string, icon: JSX.Element | undefined): JSX.Element;
}
declare class DropItem<P extends comboType> extends React.PureComponent<props<P>, states> implements IDropItem {
    state: states;
    checkFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCheckbox(text: string, icon: JSX.Element | undefined): JSX.Element;
    clickFn: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    render(): JSX.Element;
}
export { DropItem, activeStatus };
