import * as React from "react";
import * as Immutable from "immutable";
declare type props = {
    data: MenuSpace.menuData[];
    expand: boolean;
    textField?: string;
    idField?: string;
    urlField?: string;
    iconField?: string;
    defaultMenuId?: string;
};
declare type states = {
    selected: string;
    immutableData: Immutable.List<IImmutalbeMap<{
        children: Immutable.List<IImmutalbeMap<MenuSpace.menuData>>;
        [key: string]: any;
        selected: boolean;
    }>>;
    fieldObj: MenuSpace.fieldObj;
};
declare type formatterData = {
    defaultMenuId: string;
    idField: string;
};
interface INavMenu {
    formaterData(data: any[], obj: formatterData): void;
    initState(props: props): states;
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData(callback: (data: states["immutableData"], selected: string) => {
        data: states["immutableData"];
        selected: string;
    }): void;
}
declare class NavMenu extends React.PureComponent<props, states> implements INavMenu {
    static defaultProps: {
        textField: string;
        idField: string;
        iconField: string;
        urlField: string;
    };
    constructor(prop: props);
    initState(props: props): {
        selected: string;
        immutableData: any;
        fieldObj: IImmutalbeMap<{
            id: string;
            text: string;
            url: string;
            icon: string;
        }>;
    };
    formaterData(data: MenuSpace.menuData[], obj: formatterData): MenuSpace.menuData[];
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData: (callback: (data: Immutable.List<IImmutalbeMap<{
        [key: string]: any;
        children: Immutable.List<IImmutalbeMap<MenuSpace.menuData>>;
        selected: boolean;
    }>>, selected: string) => {
        data: Immutable.List<IImmutalbeMap<{
            [key: string]: any;
            children: Immutable.List<IImmutalbeMap<MenuSpace.menuData>>;
            selected: boolean;
        }>>;
        selected: string;
    }) => void;
    componentWillReceiveProps(props: props): void;
    render(): JSX.Element;
}
export default NavMenu;
