import * as React from "react";
import * as Immutable from "immutable";
import ParMenu from "./ParMenu";
import { createImmutableMap } from "../createImmutaleMap";
class NavMenu extends React.PureComponent {
    constructor(prop) {
        super(prop);
        this.changeImmutableData = (callback) => {
            this.setState(pre => {
                const { immutableData, selected } = pre;
                const { data, selected: _selected } = callback(immutableData, selected);
                return {
                    immutableData: data,
                    selected: _selected
                };
            });
        };
        this.state = this.initState(this.props);
    }
    initState(props) {
        const { defaultMenuId, data, idField, textField, urlField, iconField } = props;
        const newData = this.formaterData(data, { idField: idField, defaultMenuId: defaultMenuId });
        return {
            selected: defaultMenuId || "",
            immutableData: Immutable.fromJS(newData),
            fieldObj: createImmutableMap({
                id: idField,
                text: textField,
                url: urlField,
                icon: iconField,
            }),
        };
    }
    formaterData(data, obj) {
        const { defaultMenuId, idField } = obj;
        return data.map(par => {
            par.selected = false;
            par.children.forEach(sub => {
                sub.selected = defaultMenuId === `${par[idField]}`;
            });
            return par;
        });
    }
    getParMenu() {
        const { immutableData, fieldObj } = this.state;
        const { idField, expand } = this.props;
        return immutableData.map((node, index) => {
            return (React.createElement(ParMenu, { key: node.get(idField), node: node, expand: expand, fieldObj: fieldObj, parIndex: index, changeData: this.changeImmutableData }));
        });
    }
    componentWillReceiveProps(props) {
        if (props.data !== this.props.data) {
            const data = this.formaterData(props.data, { defaultMenuId: props.defaultMenuId, idField: props.idField });
            this.setState({
                immutableData: Immutable.fromJS(data),
                selected: props.defaultMenuId || "",
            });
        }
    }
    render() {
        const parItem = this.getParMenu();
        return (React.createElement("ul", { className: "g-menu" }, parItem));
    }
}
NavMenu.defaultProps = {
    textField: "name",
    idField: "id",
    iconField: "icon",
    urlField: "url",
};
export default NavMenu;
//# sourceMappingURL=NavMenu.js.map