import * as React from "react";
import { GroupCols } from './GroupCols';
declare type common = MyTabListSpace.common;
declare type childType = React.ComponentElement<common['groupCol'], any>;
declare type Props = {
    data: any[];
    children: childType[] | childType;
    height?: number;
    noOrder?: boolean;
    noPageNums?: boolean;
    idField: string;
    multiply?: boolean;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string;
    getCheckFn?: (fn: any) => void;
    initSelectVal?: {
        id: string;
    };
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<any>>) => void;
};
declare type States = {
    immutabData: IImmutalbeList<IImmutalbeMap<any>>;
    selectArr: IImmutalbeList<string>;
    perNums: number;
    curPage: number;
    tableData: IImmutalbeList<IImmutalbeMap<any>>;
    preData: any[];
    preInitSelect?: {
        id: string;
    };
};
declare type config = common['config'];
declare type fixObj = {
    tabField: string;
    emptyTxt: string;
    idField: string;
    multiply?: boolean;
    defaultSel: string;
};
interface ITabList {
    fieldArr: config[];
    fixObj: fixObj;
}
declare class TabList extends React.PureComponent<Props, States> implements ITabList {
    static getDerivedStateFromProps(nextProps: Props, preState: States): Partial<States> | null;
    static defaultProps: {
        height: number;
    };
    fieldArr: ITabList['fieldArr'];
    fixObj: ITabList['fixObj'];
    tabMainTabBodyDomArr: HTMLDivElement[];
    constructor(props: Props);
    getDataByPageAndPerNum(curPage: number, perNums: number, immutabData: States['immutabData']): IImmutalbeList<IImmutalbeMap<any>>;
    getFieldArr(arr: Props['children']): {
        child: {
            width: number;
            field: string;
            formatter: ((node: IImmutalbeMap<any>, index: number, tabField?: string | undefined) => React.ReactChild) | undefined;
            text: string;
            align: "left" | "right" | "center" | undefined;
        }[];
        width: number;
        forzen: boolean | undefined;
    }[];
    initFixObj(): {
        tabField: string;
        emptyTxt: string;
        idField: string;
        multiply: boolean | undefined;
        noOrder: boolean | undefined;
        defaultSel: string;
    };
    setTabBodyDom: (dom: HTMLDivElement, index: number) => void;
    changeScrollTop: (top: number, index: number) => void;
    changeState: common['changeState'];
    setSameH(): void;
    setDom(): void;
    viewMap(): JSX.Element[];
    componentDidMount(): void;
    setTabViewBottomFixHeight(): void;
    changePageHandle: (key: "perNums" | "curPage", val: number) => void;
    render(): JSX.Element;
}
export { TabList, GroupCols };
